package nl.amis.view;

import oracle.adfinternal.view.faces.application.ViewHandlerImpl;
import java.io.IOException;

import java.util.Locale;

import javax.faces.FacesException;
import javax.faces.application.ViewHandler;
import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;
import javax.faces.el.ValueBinding;


/**
 * This custom view handler sets the preferred locale on the view root
 * if it's different from the current locale, based on the preferredLocale
 * property of the session-scoped managed bean named "App".
 */
public class PreferredLanguageSettingViewHandler extends ViewHandlerImpl {
    public PreferredLanguageSettingViewHandler(ViewHandler delegate) {
        super(delegate);
    }

    public void renderView(FacesContext facesContext, UIViewRoot uIViewRoot)
            throws IOException, FacesException {
        App    app             = (App) getEl("#{App}");
        Locale preferredLocale = app.getPreferredLocale();

        if (preferredLocale == null) {
            app.setPreferredLocale(uIViewRoot.getLocale());
        } else {
            if (preferredLocale != uIViewRoot.getLocale()) {
                uIViewRoot.setLocale(preferredLocale);
            }
        }

        super.renderView(facesContext, uIViewRoot);
    }

    public static Object getEl(String expr) {
        FacesContext fc = FacesContext.getCurrentInstance();
        ValueBinding vb = fc.getApplication().createValueBinding(expr);

        return vb.getValue(fc);
    }
}


